//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class AlerteMairie: JSONDecodable, JSONEncodable, PrettyPrintable {

    public var dateDebutAlerte: Date?

    public var fateFinAlerte: Date?

    public var id: String?

    public var quartiersAlertes: [Quartier]?

    public var texteAlerte: String?

    public init(dateDebutAlerte: Date? = nil, fateFinAlerte: Date? = nil, id: String? = nil, quartiersAlertes: [Quartier]? = nil, texteAlerte: String? = nil) {
        self.dateDebutAlerte = dateDebutAlerte
        self.fateFinAlerte = fateFinAlerte
        self.id = id
        self.quartiersAlertes = quartiersAlertes
        self.texteAlerte = texteAlerte
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        dateDebutAlerte = jsonDictionary.json(atKeyPath: "dateDebutAlerte")
        fateFinAlerte = jsonDictionary.json(atKeyPath: "fateFinAlerte")
        id = jsonDictionary.json(atKeyPath: "id")
        quartiersAlertes = jsonDictionary.json(atKeyPath: "quartiersAlertes")
        texteAlerte = jsonDictionary.json(atKeyPath: "texteAlerte")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let dateDebutAlerte = dateDebutAlerte?.encode() {
            dictionary["dateDebutAlerte"] = dateDebutAlerte
        }
        if let fateFinAlerte = fateFinAlerte?.encode() {
            dictionary["fateFinAlerte"] = fateFinAlerte
        }
        if let id = id {
            dictionary["id"] = id
        }
        if let quartiersAlertes = quartiersAlertes?.encode() {
            dictionary["quartiersAlertes"] = quartiersAlertes
        }
        if let texteAlerte = texteAlerte {
            dictionary["texteAlerte"] = texteAlerte
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
